#ifndef __core__date_h
#define __core__date_h

#include "json/json_fwd.hpp"

#include <optional>

class QDate;

class Date {
public:
	using Year = unsigned int;
	using Day = unsigned char;
	enum class Month {
		Jan = 0,
		Feb,
		Mar,
		Apr,
		May,
		Jun,
		Jul,
		Aug,
		Sep,
		Oct,
		Nov,
		Dec
	};

	Date();
	Date(Year y);
	Date(Year y, Month m, Day d);
	Date(const QDate& date);
	Date(const nlohmann::json& json);
	bool IsValid() const;
	void SetYear(Year y);
	void SetMonth(Month m);
	void SetDay(Day d);
	void VoidYear();
	void VoidMonth();
	void VoidDay();
	std::optional<Year> GetYear() const;
	std::optional<Month> GetMonth() const;
	std::optional<Day> GetDay() const;
	QDate GetAsQDate() const;
	nlohmann::json GetAsAniListJson() const;

private:
	std::optional<Year> year;
	std::optional<Month> month;
	std::optional<Day> day;
};

#endif // __core__date_h
